function Create(self)
	--The number of goo particles available to pick from.
	self.gooCount = 6;
	
	--The range of the tool.
	self.range = 40;
	
	--The arc radius of the tool's beam.
	self.beamRadius = math.pi * 0.3;
	
	--The radial resolution of the beam.
	self.resolution = 0.03;
	
	--The chance of deconstructing a single partile.
	self.deconstructChance = 0.1;
end

function Update(self)
	if self:IsActivated() and not self:IsReloading() and self.RoundInMagCount > 0 then
		local aimAngle = self.RotAngle;
		if self.HFlipped then
			aimAngle = aimAngle + math.pi;
		end
		local aimVec = Vector(self.range, 0):RadRotate(aimAngle);
		local aimUp = Vector(aimVec.X, aimVec.Y):RadRotate(math.pi * 0.5):Normalize();
		local hitPos = Vector();
		
		--Cast rays in front of the gun.
		for i = -self.beamRadius * 0.5, self.beamRadius * 0.5, self.resolution do
			if math.random() < self.deconstructChance then
				if SceneMan:CastStrengthRay(self.MuzzlePos, Vector(aimVec.X, aimVec.Y):RadRotate(i), 1, hitPos, 0, 2, true) then
					local remover = CreateMOSRotating("Techion.rte/Pixel Remover");
					remover.Pos = hitPos;
					MovableMan:AddParticle(remover);
					remover:EraseFromTerrain();
					
					local piece = CreateMOPixel("Gold Particle");
					piece.Pos = hitPos;
					MovableMan:AddParticle(piece);
					piece.ToSettle = true;
					
					local glow = CreateMOPixel("Pixel Creation Glow");
					glow.Pos = hitPos;
					MovableMan:AddParticle(glow);
				end
				local mo = SceneMan:CastMORay(self.MuzzlePos, Vector(aimVec.X, aimVec.Y):RadRotate(i), self.RootID, -2, 2, false, 3)
				if mo and mo ~= 255 then
					mo = MovableMan:GetMOFromID(MovableMan:GetRootMOID(mo))
					for x = -mo.Radius - 10, mo.Radius + 10 do
						for y = -mo.Radius - 10, mo.Radius + 10 do
							if MovableMan:GetRootMOID(SceneMan:GetMOIDPixel(mo.Pos.X + x, mo.Pos.Y + y)) == mo.ID then
								mo.ToDelete = true
								local p = CreateMOPixel("Gold Particle")
								p.Pos = Vector(mo.Pos.X + x, mo.Pos.Y + y)
								MovableMan:AddMO(p)
								p.ToSettle = true
							end
						end
					end
				end
			end
		end
	end
end